//-- copyright
// Nepenthes is a free and open project management software.
// Copyright (C) 2024 The Nirvati developers
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// Nepenthes is a fork of OpenProject. The copyright follows:
//
// Copyright (C) 2012-2024 the OpenProject GmbH
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
// Copyright (C) 2006-2013 Jean-Philippe Lang
// Copyright (C) 2010-2013 the ChiliProject Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// See COPYRIGHT and LICENSE files for more details.
//++

$datepicker--selected-border-radius: 5px

@mixin disabled-day
  background: $spot-color-basic-white
  color: var(--fgColor-muted)
  pointer-events: none
  cursor: not-allowed

  &:hover
    border-color: transparent

@mixin non-working-day
  background: $spot-color-basic-gray-6
  color: var(--fgColor-muted)
  border-radius: 0
  pointer-events: none

@mixin non-working-day_enabled
  background: $spot-color-basic-gray-6
  color: $spot-color-basic-gray-1
  border-radius: 0
  pointer-events: auto

.flatpickr-current-month
  display: flex !important

.flatpickr-calendar .numInputWrapper
  position: fixed
  left: 65%

.flatpickr-prev-month, .flatpickr-next-month
  svg:hover
    fill: var(--control-checked-color) !important

.flatpickr-prev-month, .flatpickr-next-month
  svg
    fill: $spot-color-basic-gray-1 !important

.flatpickr-day
  &.flatpickr-disabled
    @include disabled-day
  &.flatpickr-non-working-day
    @include non-working-day
  &.flatpickr-non-working-day_enabled
    @include non-working-day_enabled

.flatpickr-calendar.inline
  // flatpickr default styles introduce a top: 2px, that causes strange scrolling behavior
  top: unset !important

.flatpickr-calendar
  box-shadow: none !important
  @include spot-caption

  .flatpickr-months
    min-height: 45px

    .flatpickr-current-month
      @include spot-body-small(var(--base-text-weight-bold))
      justify-content: center
      align-items: center

    .numInputWrapper
      position: relative
      left: 0

  .flatpickr-weekwrapper
    display: none

  .flatpickr-weekday
    color: var(--body-font-color)

  .flatpickr-day.prevMonthDay
    height: 0
    width: 0
    visibility: hidden

  .flatpickr-day.nextMonthDay
    display: none

  .flatpickr-weekdaycontainer,
  .flatpickr-days .dayContainer

    &:first-of-type
      padding: 0 $spot-spacing-1 0 $spot-spacing-0_5
    &:last-of-type
      padding: 0 $spot-spacing-0_5 0 $spot-spacing-1
    &:only-of-type
      padding: 0

  .flatpickr-days
    .dayContainer
      box-shadow: none
      min-width: 283px
      max-width: 283px
      display: grid
      grid-template-columns: repeat(7, 1fr)
      justify-items: center

      @media screen and (max-width: $breakpoint-sm)
        min-width: 267px
        max-width: 267px

      .flatpickr-day
        color: $spot-color-basic-gray-1
        background: $spot-color-basic-white
        width: 100%
        max-width: unset
        height: 30px
        line-height: 28px
        margin: 0
        border-radius: 0
        box-shadow: none !important

        &:hover
          border-color: var(--fgColor-muted)

        &.flatpickr-non-working-day
          @include non-working-day

        &.flatpickr-non-working-day_enabled
          @include non-working-day_enabled

        &.today:not(.selected, .inRange, .startRange, .endRange)
          background: $spot-color-indication-current-date
          border-color: $spot-color-indication-current-date
          border-radius: 0

          &:hover
            color: $spot-color-basic-gray-1
            border-color: var(--fgColor-muted)

        &.selected:not(.startRange, .endRange)
          border-radius: $datepicker--selected-border-radius

        &.selected,
        &.startRange,
        &.endRange
          background: var(--control-checked-color)
          border-color: var(--control-checked-color)
          color: $spot-color-basic-white

          &:hover
            background: var(--control-checked-color--major2)
            border-color: var(--control-checked-color--major2)

        &.startRange
          border-radius: $datepicker--selected-border-radius 0 0 $datepicker--selected-border-radius

        &.endRange
          border-radius: 0 $datepicker--selected-border-radius $datepicker--selected-border-radius 0

        &.endRange.startRange
          border-radius: $datepicker--selected-border-radius

        &.inRange
          background: var(--control-checked-color--minor1)
          color: var(--control-checked-color)
          border-color: var(--control-checked-color--minor1)
          border-radius: 0

          &:hover
            color: var(--control-checked-color--major2)
            border-color: var(--control-checked-color--major2)

          &.flatpickr-non-working-day
            background: $spot-color-basic-gray-6
            border-color: $spot-color-basic-gray-6

        &.flatpickr-disabled
          @include disabled-day

          &.flatpickr-non-working-day
            background: $spot-color-basic-gray-6
            color: var(--fgColor-muted)

          &.flatpickr-non-working-day_enabled
            background: $spot-color-basic-gray-6
            color: var(--fgColor-muted)

            &.inRange
              color: var(--fgColor-muted)
              background: $spot-color-basic-gray-6
              border-color: $spot-color-basic-gray-6

          &.selected,
          &.startRange,
          &.endRange
            background: var(--fgColor-muted)
            border-color: var(--fgColor-muted)
            color: $spot-color-basic-gray-5

          &.inRange
            background: $spot-color-basic-gray-5
            border-color: $spot-color-basic-gray-5
            color: var(--fgColor-muted)

          &.today
            color: var(--fgColor-muted)
            background: $spot-color-indication-current-date
            border-color: $spot-color-indication-current-date

.flatpickr-calendar.flatpickr-container-suppress-hover
  .flatpickr-day
    &.inRange,
    &.startRange:not(.selected),
    &.endRange:not(.selected)
      background: transparent !important
      border-color: transparent !important
      color: $spot-color-basic-gray-1 !important

    &.flatpickr-non-working-day:not(.today,.selected)
      background: $spot-color-basic-gray-6 !important
      color: var(--fgColor-muted) !important

    &.flatpickr-non-working-day_enabled:not(.today,.selected)
      background: $spot-color-basic-gray-6 !important
      color: $spot-color-basic-gray-1 !important

      &.today
        color: $spot-color-basic-gray-1 !important

      &.inRange,
      &.startRange:not(.selected),
      &.endRange:not(.selected)
        color: $spot-color-basic-gray-1 !important
        background: $spot-color-basic-gray-6 !important
        border-color: $spot-color-basic-gray-6 !important

.flatpickr-calendar:not(.inline)
  box-shadow: $spot-shadow-light-mid !important
  padding: $spot-spacing-0_5 !important
  width: max-content !important

  .flatpickr-months
    display: flex
    align-items: flex-start

  .flatpickr-next-month, .flatpickr-prev-month
    position: static !important
